#define _ijps 0
#define _CRT_SECURE_NO_DEPRECATE
#pragma comment(linker, "/STACK:667772160")
#include <iostream>
#include <cmath>
#include <vector>
#include <time.h>
#include <map>
#include <set>
#include <deque>
#include <cstdio>
#include <cstdlib>
#include <unordered_map>
#include <bitset>
#include <algorithm>
#include <string>
#include <fstream>
#include <assert.h>
#include <list>
#include <cstring>
using namespace std;

#define name "numpalindrome"
typedef unsigned long long ull;
typedef long long ll;
#define mk make_pair
#define forn(i, n) for(ll i = 0; i < (ll)n; i++)
#define fornn(i, q, n) for(ll i = (ll)q; i < (ll)n; i++)
#define times clock() * 1.0 / CLOCKS_PER_SEC

struct __isoff{
	__isoff(){
		if (_ijps)
			freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);//, freopen("test.txt", "w", stderr);
		else freopen(name".in", "r", stdin), freopen(name".out", "w", stdout);
		//ios_base::sync_with_stdio(0);
		//srand(time(0));
		srand('C' + 'T' + 'A' + 'C' + 'Y' + 'M' + 'B' + 'A');
	}
	~__isoff(){
		//if(_ijps) cout<<times<<'\n';
	}
} __osafwf;
const ull p1 = 131;
const ull p2 = 129;
const double eps = 1e-7;
const double pi = acos(-1.0);

const int infi = 1e9 + 7;
const ll inf = 1e18 + 7;
const ll dd = 5e5 + 7;
const ll mod = 1e9 + 7;

vector<int> Palindrom1(string s){
	int n = s.size();
	vector<int> d1(n);
	int l = 0, r = -1;
	for (int i = 0, k; i < n; i++){
		if (i > r) 
			k = 1;
		else 
			k = min(d1[l + r - i], r - i);
		while (0 <= i - k && i + k < n && s[i - k] == s[i + k]) 
			k++;
		d1[i] = k;
		if (i + k - 1 > r)
			r = i + k - 1, l = i - k + 1;
	}
	return d1;
}
vector<int> Palindrom2(string s){
	int n = s.size();
	vector<int> d2(n);
	int l = 0, r = -1;
	for (int i = 0, k; i < n; i++){
		if (i > r) 
			k = 0;
		else 
			k= min(d2[l + r - i + 1], r - i + 1);
		while (i + k < n && i - k - 1 >= 0 && s[i + k] == s[i - k - 1]) 
			k++;
		d2[i] = k;
		if (i + k - 1 > r)
			l = i - k, r = i + k - 1;
	}
	return d2;
}

struct ev{
	int index, type, s, x;
	ev(){

	}
	ev(int index, int type, int s, int x) : index(index), type(type), s(s), x(x){

	}
	bool operator < (ev b) const{
		if(x == b.x){
			return type < b.type;
		}
		return x < b.x;
	}

};

vector<ev> LA, RA;
vector<ll> Ans;

struct fenwTree{
	ll Sum[dd] = {};
	int F(int x){
		return x & -x;
	}
	ll get(int l){
		ll s = 0;
		for(l++; l; l -= F(l)){
			s += Sum[l];
		}
		return s;
	}
	void up(int t, ll x){
		for(t++; t < dd; t += F(t)){
			Sum[t] += x;
		}
	}
	ll get(int l, int r){
		return get(r) - get(l - 1);
	}
};

vector<ll> PrefSumL;
vector<ll> PrefSumR;

int main(){
	int n, m;
	string s;
	cin >> n >> m >> s;
	Ans.resize(m);
	n = s.size();
	vector<int> P1 = Palindrom1(s);
	vector<int> P2 = Palindrom2(s);
	forn(i, n){
		int l = i - P1[i] + 1;
		int r = i;
		LA.push_back(ev(-1, -2, l, r));
		if(i + 1 < n && P2[i + 1] > 0){
			l = i - P2[i + 1] + 1;
			r = i;
			LA.push_back(ev(-1, -2, l, r));
		}
	}
	forn(i, n){
		int l = i;
		int r = i + P1[i] - 1;
		RA.push_back(ev(-1, 2, r, l));
		if(P2[i] > 0){
			l = i;
			r = i + P2[i] - 1;
			RA.push_back(ev(-1, 2, r, l));
		}
	}
	PrefSumL.resize(n + 2);
	PrefSumR.resize(n + 2);
	forn(i, LA.size()){
		PrefSumL[LA[i].x + 1] += LA[i].x + 1;
	}
	forn(i, RA.size()){
		PrefSumR[RA[i].x + 1] -= RA[i].x - 1;
	}
	fornn(i, 1, n + 2){
		PrefSumL[i] += PrefSumL[i - 1];
		PrefSumR[i] += PrefSumR[i - 1];
	}
	forn(i, m){
		int l, r;
		scanf("%d%d", &l, &r);
		l--, r--;
		if(0 && r - l < 4){
			for (int j = l; j <= r; j++){
				string t;
				for (int k = j; k <= r; k++){
					t.push_back(s[k]);
					bool is = 1;
					for (int l = 0; l < t.size(); l++){
						if (t[l] != t[t.size() - 1 - l]){
							is = 0;
						}
					}
					Ans[i] += is;
				}
			}
		}
		else{
			int sl = (l + r) / 2;
			int sr = sl + 1;
			if((r - l) % 2 == 1){
				Ans[i] -= min((r - l + 1) / 2, P2[(r + l + 1) / 2]);
			}
			else{
				sl--;
				Ans[i] += min((r - l) / 2 + 1, P1[(r + l) / 2]);
			}
			LA.push_back(ev(i, -1, l, sl));
			LA.push_back(ev(i, +1, l, l - 1));

			RA.push_back(ev(i, +1, r, sr));
			RA.push_back(ev(i, -1, r, r + 1));

			Ans[i] += PrefSumL[sl + 1] - PrefSumL[l];
			Ans[i] += PrefSumR[r + 1] - PrefSumR[sr];
		}
	}

	sort(LA.begin(), LA.end());
	sort(RA.begin(), RA.end());
	reverse(RA.begin(), RA.end());
	{
		fenwTree Q, W;
		forn(i, LA.size()){
			if(LA[i].index == -1){
				Q.up(LA[i].s, 1);
				W.up(LA[i].s, LA[i].s);
			}
			else{
				int in = LA[i].index;
				ll a = LA[i].s * Q.get(LA[i].s);
				ll b = W.get(LA[i].s + 1, dd - 2);
				ll s = LA[i].type * (a + b);
				Ans[in] += s;
			}
		}
	}
	{
		fenwTree Q, W;
		forn(i, RA.size()){
			if(RA[i].index == -1){
				Q.up(RA[i].s, 1);
				W.up(RA[i].s, RA[i].s);
			}
			else{
				int in = RA[i].index;
				ll a = (RA[i].s) * Q.get(RA[i].s + 1, dd - 2);
				ll b = W.get(RA[i].s);
				ll s = RA[i].type * (a + b);
				Ans[in] += s;
			}
		}
	}
	forn(i, m){
		cout << Ans[i] << '\n';
	}
}