#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXL = 100;
const int MAXVAL = 1e5;

int number_l, lp, lm;

string gen_number() {
    string ret = "";
    if (number_l == 1) {
        ret += '0' + rnd.next(0, 9);
    } else {
        ret += '0' + rnd.next(1, 9);
        for (int i = 1; i < number_l; ++i) {
            ret += '0' + rnd.next(0, 9);
        }
    }
    return ret;
}

string gen_mul() {
    string ret;

    ll nowp = 1;
    while (true) {
        int tmp = rnd.next(0, 3);
        string next = ret;
        if (tmp == 0) {
            if (szof(next) && '0' <= next.back() && next.back() <= '9') {
                next += "*";
            }
            string num = gen_number();
            ll val = 0;
            for (char c: num) {
                val = val * 10 + c - '0';
            }
            if (val * nowp > MAXVAL) {
                num = "0";
                nowp = 0;
            } else {
                nowp *= val;
            }

            next += num;
        } else if (tmp == 1) {
            if (szof(next) && rnd.next(0, 1)) {
                next += "*";
            }
            next += "nm"[rnd.next(0, 1)];
        } else {
            if (szof(next) && rnd.next(0, 1)) {
                next += "*";
            }
            next += "nm"[rnd.next(0, 1)];
            next += "^";
            next += gen_number();
        }
        if (szof(next) > lm) {
            break;
        }
        ret = next;
    }
    return ret;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    assert(argc >= 2);

    int t = atoi(argv[1]);

    number_l = 1;
    if (argc >= 3) {
        number_l = atoi(argv[2]);
    }

    lm = 30;
    if (argc >= 4) {
        lm = atoi(argv[3]);
    }
    lp = MAXL;
    if (argc >= 5) {
        lp = atoi(argv[4]);
    }

    cout << t << "\n";

    for (int i = 0; i < t; ++i) {
        string now = "";
        while (true) {
            string mul = gen_mul();
            string next = now;

            int sign = rnd.next(0, 1);
            if (sign) {
                next += "-";
            } else if (szof(now)) {
                next += "+";
            }
            next += mul;
            if (szof(next) > lp) {
                break;
            }
            now = next;
        }
        cout << now << "\n";
    }
    
    return 0;
}