#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) (_x).begin(), (_x).end()
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int MAXT = 100, MAXL = 100;
const int MAXVAL = 1e5;

int validate_number(string s) {
    if (szof(s) == 0) {
        return 0;
    }
    if (szof(s) > 5 && s != "100000") {
        return 0;
    }
    if (s.front() == '0' && szof(s) != 1) {
        return 0;
    }
    for (char c: s) {
        if (c < '0' || c > '9') {
            return 0;
        }
    }
    return 1;
}

int validate_mul(string s) {
    if (szof(s) == 0) {
        return 0;
    }
    vector<string> v;
    string now;
    for (int i = 0; i < szof(s); ++i) {
        if (s[i] < '0' || s[i] > '9') {
            if (szof(now)) {
                v.puba(now);
            }
            now = "";
            string tmp;
            tmp += s[i];
            v.puba(tmp);
        } else {
            now += s[i];
        }
    }
    if (szof(now)) {
        v.puba(now);
    }

    ll nowp = 1;
    bool flag = false;
    bool zero_flag = false;
    int power[2] = {0, 0};
    for (int i = 0; i < szof(v); ++i) {
        if (v[i] == "^") {
            if (i == 0 || (v[i - 1] != "n" && v[i - 1] != "m")) {
                return 0;
            }
            if (i == szof(v) - 1 || (v[i + 1].front() < '0' || v[i + 1].front() > '9')) {
                return 0;
            }
        }
        if (v[i] == "*") {
            if (i == 0 || v[i - 1] == "^") {
                return 0;
            }
            if (i == szof(v) - 1 || v[i + 1] == "^") {
                return 0;
            }
        }
        if ('0' <= v[i].front() && v[i].front() <= '9') {
            if (!validate_number(v[i])) {
                return 0;
            }
            if (i == 0 || v[i - 1] != "^") {
                ll tmp = 0;
                for (char c: v[i]) {
                    tmp = tmp * 10 + c - '0';
                }
                if (nowp * tmp > MAXVAL) {
                    flag = true;
                }
                nowp *= tmp;
                if (v[i] == "0") {
                    zero_flag = true;
                }
            }
        }
        if (v[i] == "n" || v[i] == "m") {
            int pos = (v[i] == "m");
            if (i == szof(v) - 1 || v[i + 1] != "^") {
                power[pos] += 1;
            } else {
                if (i + 2 >= szof(v) || v[i + 2].front() < '0' || v[i + 2].front() > '9') {
                    return 0;
                }
                power[pos] += atoi(v[i + 2].c_str());
            }
        }
    }

    if (power[0] > MAXVAL || power[1] > MAXVAL) {
        return 0;
    }
    if (flag && !zero_flag) {
        return 0;
    }

    return 1;
}

int validate_polynom(string s) {
    if (szof(s) == 0) {
        return 0;
    }
    vector<string> v;
    if (s[0] == '+') {
        return 0;
    }
    string now;
    for (int i = 0; i < szof(s); ++i) {
        char c = s[i];
        if (c == '+' || c == '-') {
            if (i > 0) {
                v.puba(now);
            }
            now = "";
        } else {
            now += c;
        }
    }

    if (szof(now)) {
        v.puba(now);
    }

    for (auto mul: v) {
        if (!validate_mul(mul)) {
            return 0;
        }
    }
    return 1;
}

int main() {
    registerValidation();
    
    int t = inf.readInt(1, MAXT); inf.readEoln();
    
    for (int i = 0; i < t; ++i) {
        string s = inf.readToken();
        ensure(szof(s) <= MAXL);
        inf.readEoln();
        ensure(validate_polynom(s));
    }

    inf.readEof();

    return 0;
}