#include <fstream>
#include <string>
#include <map>

using namespace std;

int main()
{
	ios::sync_with_stdio(false);
	ifstream cin("polynomial.in");
	ofstream cout("polynomial.out");
	int k;
	cin >> k;

	map <pair <int, int>, int> add;
	for (int i = 0; i < k; i++)
	{
		string s;
		cin >> s;
		add.clear();
		int sign = 1;
		for (int i = 0; i < (int) s.size(); i++)
		{
			int n = 0, m = 0, coef = 1, var = -1;
			while (i < (int) s.size() && s[i] != '-' && s[i] != '+')
			{
				if (s[i] == '^')
				{
					if (i)
					{
						s[i - 1] == 'n' ? var = 0 : var = 1;
					}
				}
				else if (s[i] >= '0' && s[i] <= '9')
				{
					int number = 0;
					while (i < (int) s.size() && s[i] >= '0' && s[i] <= '9')
					{
						number *= 10;
						number += s[i] - '0';
						++i;
					}
					var == -1 ? coef *= number : (var == 0 ? n += number : m += number);
					var = -1;
					--i;
				}
				else if (s[i] == 'n' && (i + 1 < (int) s.size() && s[i + 1] != '^' || i == (int) s.size() - 1))
				{
					++n;
				}
				else if (s[i] == 'm' && (i + 1 < (int) s.size() && s[i + 1] != '^' || i == (int) s.size() - 1))
				{
					++m;
				}
				++i;
			}
			if (!(!i && (s[i] == '+' || s[i] == '-')))
			{
				add[make_pair(n, m)] += sign * coef;
			}
			if (i < (int) s.size())
			{
				s[i] == '+' ? sign = 1 : sign = -1;
			}
		}
		int size = 0;
		for (auto it = add.begin(); it != add.end(); it++)
		{
			if (it->second)
			{
				if (abs(it->second) == 1)
				{
					if (it->first.first == 0 && it->first.second == 0)
					{
						if (it->second == 1)
						{
							if (size > 0)
							{
								cout << "+";
							}
							cout << 1;
						}
						else
						{
							cout << -1;
						}
					}
					else if (it->second == 1 && size > 0)
					{
						cout << "+";
					}
					else if (it->second == -1)
					{
						cout << "-";
					}
				}
				else
				{
					if (it->second > 0 && size > 0)
					{
						cout << "+";
					}
					cout << it->second;
				}
				if (it->first.first)
				{
					cout << "n";
					if (it->first.first > 1)
					{
						cout << "^" << it->first.first; 
					}
				}
				if (it->first.second)
				{
					cout << "m";
					if (it->first.second > 1)
					{
						cout << "^" << it->first.second;
					}
				}
				++size;
			}
		}
		if (!size)
		{
			cout << 0;
		}
		cout << "\n";
	}
	return 0;
}