if [ "$#" -ne "4" ]; then
    read
fi
if [ "$1" = "" ]; then
    read
fi
if [ "$2" = "" ]; then
    read
fi
if [ ! -f "$1" ]; then
    read
fi
echo "Running validator"
wine files/towin.exe "$1" | java -Xmx512M -Xss64M -DONLINE_JUDGE=true -Duser.language=en -Duser.region=US -Duser.variant=US -jar files/Validate.jar --testset "$3" --group "$4"
if [ "$?" -ne "0" ]; then
    read
fi
cp $1 presuf.in
echo "Running solution presuf_gs.cpp"
wine solutions/presuf_gs.exe
if [ "$?" -ne "0" ]; then
    echo "Solution returned non-zero exit code"
    read
fi
rm -f presuf.in
if [ ! -f "presuf.out" ]; then
    echo "Solution didn't produced output [presuf.out]"
    read
fi
mv "presuf.out" "$2"
echo "Running checker"
java -Xmx512M -Xss64M -DONLINE_JUDGE=true -Duser.language=en -Duser.region=US -Duser.variant=US -jar check.jar $1 $2 $2
if [ "$?" -ne "0" ] && [ "$?" -ne "7" ]; then
    echo "Checker exit code is not equal to 0 and 7"
    read
fi
