#include<bits/stdc++.h>
using namespace std;

vector<int> pref(int n) 
{
    vector<int> digits;
    while (n > 0)
        digits.push_back(n % 10), n /= 10;
    reverse(digits.begin(), digits.end());
    vector<int> res(1, digits[0]);
    for (int i = 1; i < (int)digits.size(); i++)
        res.push_back(res[i - 1] * 10 + digits[i]);
    return res;
}

vector<int> suf(int n) 
{
    vector<int> res;
    for (int i = 1; i <= n; i *= 10)
        res.push_back(n % (i * 10));
    return res;
}


int main() 
{
    srand(time(NULL));
    freopen("presuf.in", "r", stdin);
    freopen("presuf.out", "w", stdout);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < 10000; i++)
    {
        int x = rand() % n;
        int y = rand() % n;
        vector<int> resx = pref(a[x]);
        vector<int> resy = suf(a[y]);
        bool ok = false;
        for (int j = 0; j < (int)resx.size() && j < (int)resy.size(); j++)
            if (resx[j] == resy[j])
                ok = true;
        if (ok)
        {
            cout << x + 1 << " " << y + 1 << endl;
            return 0;
        }
    }
    cout << -1 << endl;
    return 0;
}