#include <bits/stdc++.h>

bool update(std::string &s, const std::string &bound) {
  int k = static_cast<int>(s.size()) - static_cast<int>(bound.size());
  if (k < 0) {
    return true;
  }
  std::vector<std::vector<int>> prev(s.size(), std::vector<int>(10, -1));
  for (int i = static_cast<int>(s.size()) - 2; i >= 0; i--) {
    for (int d = 0; d < 10; d++) {
      if (s[i + 1] - '0' == d) {
        prev[i][d] = i + 1;
      } else {
        prev[i][d] = prev[i + 1][d];
      }
    }
  }
  std::string foundResult = "";
  int pos = 0;
  bool used = false;
  int BOUND = static_cast<int>(s.size()) - k - 1;
  //std::cerr << BOUND << '\n';
  for (int i = 0; i < BOUND; i++) {
    for (int d = 9; d >= 0; d--) {
      int npos = prev[pos][d];
      if (pos == 0 && s[0] - '0' == d && !used) {
        npos = 0;
        used = true;
      }
      if (npos == -1) {
        continue;
      }
      if (s.size() - npos >= BOUND - i) {
        foundResult += (char)(d + '0');
        pos = npos;
        break;
      }
    }
  }
  for (int prefix = 0; prefix <= static_cast<int>(bound.size()); prefix++) {
    size_t i = 0;
    size_t l = 0;
    std::string ns = "";
    while (i < s.size() && l < prefix && k > 0) {
      if (s[i] == bound[l]) {
        ns += s[i];
        l++;
        k++;
      }
      i++;
      k--;
    }
    if (i == s.size() || k == 0) {
      continue;
    }
    if (prefix == static_cast<int>(bound.size()) && l == prefix) {
      s = ns;
      return true;
    }
    i = std::max<int>(0, i - 1);
    bool found = false;
    for (int d = 1; d < bound[l] - '0'; d++) {
      int pos = prev[i][d];
      if (i == 0 && s[0] - '0' == d) {
        pos = 0;
      }
      if (pos == -1) {
        continue;
      }
      if (s.size() - pos >= bound.size() - l) {
        found = true;
        std::cerr << d << '\n';
        break;
      }
    }
    std::cerr << "prefix: " << prefix << ", found: " << found << '\n';
    std::cerr << ns << '\n';
    if (!found) {
      continue;
    }
    bool used = false;
    bool isLess = false;
    std::cerr << "!";
    while (ns.size() < bound.size()) {
      int sd = isLess ? 9 : bound[l] - '0' - 1;
      for (int d = sd; d >= 1; d--) {
        int pos = prev[i][d];
        if (i == 0 && s[0] - '0' == d && !used) {
          pos = 0;
          used = true;
        }
        if (pos == -1) {
          continue;
        }
        if (s.size() - pos >= bound.size() - l) {
          ns += (char)(d + '0');
          std::cerr << d << '\n';
          isLess |= d < bound[l] - '0';
          i = pos;
          l++;
          break;
        }
      }
    }
    std::cerr << "?";
    foundResult = ns;
  }
  if (foundResult.size() == 0) {
    return false;
  }
  s = foundResult;
  return true;
}

int main() {
  freopen("recovery.in", "r", stdin);
  freopen("recovery.out", "w", stdout);
  int n;
  std::cin >> n;
  std::vector<std::string> s(n);
  for (int i = 0; i < n; i++) {
    std::cin >> s[i];
  }
  std::vector<std::string> result = s;
  int answer = 0;
  for (int i = n - 2; i >= 0; i--) {
    std::cerr << result[i] << ' ' << result[i + 1] << '\n';
    if (!update(result[i], result[i + 1])) {
      //std::cerr << i + 1 << ' ' << result[i + 1] << '\n';
      std::cout << "-1\n";
      return 0;
    }
    std::cerr << result[i] << '\n';
    answer += static_cast<int>(s[i].size() - result[i].size());
  }
  std::cout << answer << '\n';
  return 0;
}