#include <bits/stdc++.h>
#define sz(x) ((int)(x).size())

using namespace std;

int n;
vector < vector < int > > e;
vector < int > vp, t1, t2;
int ct;

void dfs(int v, int p)
{
	vp[v] = p;
	t1[v] = ++ct;
	for (int i = 0; i < sz(e[v]); ++i)
	{
		int nv = e[v][i];
		if (nv == p)
		{
			e[v][i] = e[v].back();
			e[v].pop_back();
			--i;
			continue;
		}
		dfs(nv, v);
	}
	t2[v] = ++ct;
}

int main()
{
#ifndef LOCAL
	freopen("treefirstedge.in", "r", stdin);
	freopen("treefirstedge.out", "w", stdout);
#endif
	ios::sync_with_stdio(false);

	cin >> n;
	e.resize(n);
	vp.resize(n);
	t1.resize(n);
	t2.resize(n);
	for (int i = 0; i < n - 1; ++i)
	{
		int x, y;
		cin >> x >> y;
		--x;
		--y;
		e[x].push_back(y);
		e[y].push_back(x);
	}
	dfs(0, -1);

	int m;
	cin >> m;
	while (m--)
	{
		int x, y;
		cin >> x >> y;
		--x;
		--y;
		if (t1[x] < t1[y] && t2[y] < t2[x])
		{
			int l = 0, r = sz(e[x]) - 1;
			while (l < r)
			{
				int mid = (l + r + 1) / 2;
				if (t1[e[x][mid]] <= t1[y])
					l = mid;
				else
					r = mid - 1;
			}
			cout << e[x][l] + 1 << "\n";
		} else
			cout << vp[x] + 1 << "\n";
	}

	return 0;
}
