#include "testlib.h"
using namespace std;

const int MAX = 1e6;

int main() 
{
    registerValidation();

    for (int i = 0; i < 3; i++)
    {
    	int a = inf.readInt(1, MAX, format("a[%d]", i + 1));
    	inf.readSpace();
    	int b = inf.readInt(1, MAX, format("b[%d]", i + 1));
    	inf.readSpace();
    	int c = inf.readInt(1, MAX, format("c[%d]", i + 1));
    	inf.readEoln();

    	ensuref(a + b > c, "The triangle inequality must hold");
    	ensuref(c + b > a, "The triangle inequality must hold");
    	ensuref(a + c > b, "The triangle inequality must hold");
    }
    inf.readEof();

    return 0;
}