#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int sign(int x) {
	if (x > 0) return 1;
	if (x < 0) return -1;
	return 0;
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);
	if (argc < 2) {
		cerr << "Usage: gen_random <winner>(-1..1) <maxDif> " << endl;
		return 1;
	}
	int winner = atoi(argv[1]);
	int maxDif = atoi(argv[2]);

	const int coef[3] = { 3, 20, 120 };
	vector<vector<int> > a(2, vector<int>(3));
	while (1) {
		vector<int> b;
		for (int i = 0; i < 2; i++) {
			int cur = 0;
			for (int j = 0; j < 3; j++) {
				a[i][j] = rnd.next(1001);
				cur += a[i][j] * coef[j];
			}
			b.push_back(cur);
		}
		if (sign(b[0] - b[1]) == winner && abs(b[0] - b[1]) <= maxDif) break;
	}
	for (int i = 0; i < 2; i++) {
		for (int j = 0; j < 3; j++) {
			cout << a[i][j] << " \n"[j + 1 == 3];
		}
	}

	return 0;
}
