/**
 *    author:  [itmo] enot.1.10
 *    created: 01.10.2016 12:36:30       
**/
#define __USE_MINGW_ANSI_STDIO 0
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;

/* --- main part --- */


const int N = 5e5 + 10;
int n, m;

char s[N];

int mx1[N];
int mx2[N];



int main()
{
    assert(freopen("numpalindrome.in", "r", stdin));
    assert(freopen("numpalindrome.out", "w", stdout));
    scanf("%d%d", &n, &m);    
    scanf("%s", s);
    forn(i, n)
    {
        mx1[i] = 1;
        int l = i - 1;
        int r = i + 1;
        while (0 <= l && r < n && s[l] == s[r])
        {
            mx1[i]++;
            --l;
            ++r;
        }
    }
    forn(i, n - 1)
    {
        mx2[i] = 0;
        int l = i;
        int r = i + 1;
        while (0 <= l && r < n && s[l] == s[r])
        {
            mx2[i]++;
            --l, ++r;
        }
    }
    forn(_, m)
    {
        int l, r;
        scanf("%d%d", &l, &r);
        --l, --r;
        int res = 0;
        for (int i = l; i <= r; ++i)
        {
            res += min({mx1[i], i - l + 1, r - i + 1});
        }
        for (int i = l; i < r; ++i)
        {
            res += min({mx2[i], i - l + 1, r - i});
        }
        printf("%d\n", res);
    }
    
    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
