#include "bits/stdc++.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME "polynomial"

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXL = 1e6 + 5;

int t;
char s[MAXL];

int main() {
    freopen(TASK_NAME ".in", "r", stdin);
    freopen(TASK_NAME ".out", "w", stdout);

    scanf("%d", &t);

    for (int i = 0; i < t; ++i) {
        cerr << i << endl;
        scanf("%s", s);
        int n = strlen(s);
        if (s[0] != '-') {
            for (int j = n - 1; j >= 0; --j) {
                s[j + 1] = s[j];
            }
            s[0] = '+';
            ++n;
        }
        int prev = 0;
        map<pii, int> have;
        for (int j = 1; j <= n; ++j) {
            if (j == n || s[j] == '-' || s[j] == '+') {
                int sign = s[prev] == '-' ? -1 : 1;

                int prod = 1;
                int power[2] = {0, 0};
                int now = 0;
                bool flag = false;
                for (int k = prev + 1; k < j; ++k) {
                    if (s[k] == 'n' || s[k] == 'm') {
                        int tmp = (s[k] == 'm');
                        if (flag) {
                            prod *= now;
                        }
                        now = 0;
                        flag = false;
                        int npow = 1;
                        if (k + 1 < j && s[k + 1] == '^') {
                            k += 2;
                            npow = 0;
                            for (; k < j && '0' <= s[k] && s[k] <= '9'; ++k) {
                                npow = npow * 10 + s[k] - '0';
                            }
                            --k;
                        }
                        power[tmp] += npow;
                    } else if (s[k] == '*') {
                        if (flag) {
                            prod *= now;
                        }
                        now = 0;
                        flag = false;
                    } else {
                        now = now * 10 + s[k] - '0';
                        flag = true;
                    }
                }

                if (flag) {
                    prod *= now;
                }

                //cerr << sign * prod << " * n ^ " << power[0] << " * m ^ " << power[1] << endl;
                have[{power[0], power[1]}] += sign * prod;

                prev = j;
            }
        }

        vector<vector<int>> ans;
        for (auto p: have) {
            if (p.ss) {
                ans.puba({p.ff.ff, p.ff.ss, p.ss});
            }
        }
        sort(bend(ans));
        bool flag = true;
        for (auto v: ans) {
            if (v[2] > 0 && !flag) {
                cout << "+";
            }

            if (v[2] == -1) {
                cout << "-";
            }

            if (abs(v[2]) != 1) {
                cout << v[2];
            }

            if (v[0] == 1) {
                cout << "n";
            } else if (v[0] > 1) {
                cout << "n^" << v[0];
            }

            if (v[1] == 1) {
                cout << "m";
            } else if (v[1] > 1) {
                cout << "m^" << v[0];
            }


            flag = false;
        }

        if (szof(ans) == 0) {
            cout << 0;
        }

        cout << "\n";
    }        

    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}