#include <bits/stdc++.h>
#define sz(x) ((int)(x).size())

using namespace std;

int n;
vector < vector < int > > e;
vector < int > vp, dep;

void dfs(int v, int p, int cd)
{
	vp[v] = p;
	dep[v] = cd;
	for (int nv : e[v])
		if (nv != p)
			dfs(nv, v, cd + 1);
}

int main()
{
#ifndef LOCAL
	freopen("treefirstedge.in", "r", stdin);
	freopen("treefirstedge.out", "w", stdout);
#endif
	ios::sync_with_stdio(false);

	cin >> n;
	e.resize(n);
	vp.resize(n);
	dep.resize(n);
	for (int i = 0; i < n - 1; ++i)
	{
		int x, y;
		cin >> x >> y;
		--x;
		--y;
		e[x].push_back(y);
		e[y].push_back(x);
	}
	dfs(0, -1, 0);

	int m;
	cin >> m;
	while (m--)
	{
		int x, y;
		cin >> x >> y;
		--x;
		--y;
		if (dep[y] <= dep[x])
			cout << vp[x] + 1 << "\n";
		else
		{
			while (dep[y] > dep[x] + 1)
				y = vp[y];
			if (vp[y] == x)
				cout << y + 1 << "\n";
			else
				cout << vp[x] + 1 << "\n";
		}
	}

	return 0;
}
